

CREATE TABLE [dbo].[Customers](
	[CustomerId] [int] NOT NULL,
	[Name] [varchar](100) NOT NULL,
	[Country] [varchar](50) NOT NULL
) ON [PRIMARY]

GO

SET ANSI_PADDING OFF
GO

INSERT INTO Customers
SELECT 1, 'John Hammond', 'United States'
UNION ALL
SELECT 2, 'Mudassar Khan', 'India'
UNION ALL
SELECT 3, 'Suzanne Mathews', 'France'
UNION ALL
SELECT 4, 'Robert Schidner', 'Russia'

GO

CREATE PROCEDURE [dbo].[Update_Customers]
	@tblCustomers CustomerType READONLY
AS
BEGIN
	SET NOCOUNT ON;
	--UPDATE EXISTING RECORDS
	UPDATE Customers
	SET Name = c2.Name
	,Country = c2.Country
	FROM Customers c1
	INNER JOIN @tblCustomers c2 
	ON c1.CustomerId = c2.Id

	--INSERT NON-EXISTING RECORDS
	INSERT INTO Customers
	SELECT Id, Name, Country
	FROM @tblCustomers 
	WHERE Id NOT IN (SELECT CustomerId FROM Customers)
END

GO

CREATE PROCEDURE [dbo].[Update_Customers_MERGE]
      @tblCustomers CustomerType READONLY
AS
BEGIN
	SET NOCOUNT ON;

	MERGE INTO Customers c1
	USING @tblCustomers c2
	ON c1.CustomerId=c2.Id
	WHEN MATCHED THEN
	UPDATE SET c1.Name = c2.Name
		,c1.Country = c2.Country
	WHEN NOT MATCHED THEN 
	INSERT VALUES(c2.Id, c2.Name, c2.Country);
END


